.SECONDARY:

polyml-5.7.tar.gz:
	wget https://github.com/polyml/polyml/archive/v5.7.tar.gz -O $@
	md5sum -c $@.md5

polyml-5.7: polyml-5.7.tar.gz
	tar xzf $<

polyml-%/local/bin/poly: polyml-%
	@mkdir -p `dirname $@`
	cd $< && ./configure --prefix=$(shell pwd)/$</local && make && make install

HOL:
	git clone git://github.com/HOL-Theorem-Prover/HOL.git
	cd $@ && git checkout a0f691744824b8f2460f2df781bc871aa77e39a1

HOL/tools-poly/poly-includes.ML: HOL polyml-5.7/local/bin/poly
	echo "val polymllibdir = \"`pwd`/polyml-5.7/local/lib\";" > $@

HOL/bin/build: HOL/tools-poly/poly-includes.ML
	cd HOL && ../polyml-5.7/local/bin/poly < tools/smart-configure.sml

HOL/bin/hol: HOL/bin/build
	cd HOL && bin/build
